-- frekvencia oszto 1:10 hez
-- VaJo
-- quartus II sp13.0.1
library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;

entity div is
    port(clk : in std_logic; -- clk
			rst : in std_logic; -- rst
			f5MHz : inout std_logic;
			f500kHz : inout std_logic;
			f50kHz: inout std_logic;
			f5kHz : inout std_logic;
			f500Hz: inout std_logic;
			f50Hz : inout std_logic;
			f5Hz  : inout std_logic;
			f1Hz  : inout std_logic);
end entity div;

architecture Behavioral of div is
	--signal tmp: std_logic_vector(2 downto 0);
	component div_10
		port(clk : in std_logic; -- clk
			  ce : in std_logic; -- engedelyezo
			  dir: in std_logic;
			  rst: in std_logic;
			  q : out std_logic);
	end component;
begin

-- 50 MHz => 5MHz
c_f5MHZ: div_10
	port map 
		(
		  clk => clk,
		  ce  => '1',
		  dir => '1',
		  rst => rst,
		  q   => f5MHz
		);
-- 5 MHz => 500kHz
c_f500kHZ: div_10
	port map 
		(
		  clk => f5MHz,
		  ce  => '1',
		  dir => '1',
		  rst => rst,
		  q   => f500kHz
		);
-- 500 kHz => 50kHz
c_f50kHZ: div_10
	port map 
		(
		  clk => f500kHz,
		  ce  => '1',
		  dir => '1',
		  rst => rst,
		  q   => f50kHz
		);	 
-- 50 kHz => 5kHz
c_f5kHZ: div_10
	port map 
		(
		  clk => f50kHz,
		  ce  => '1',
		  dir => '1',
		  rst => rst,
		  q   => f5kHz
		);	 	 
-- 5 kHz => 500Hz
c_f500HZ: div_10
	port map 
		(
		  clk => f5kHz,
		  ce  => '1',
		  dir => '1',
		  rst => rst,
		  q   => f500Hz
		);	 	 
-- 500 Hz => 50Hz
c_f50HZ: div_10
	port map 
		(
		  clk => f500Hz,
		  ce  => '1',
		  dir => '1',
		  rst => rst,
		  q   => f50Hz
		);	 	 
-- 50 Hz => 5Hz
c_f5HZ: div_10
	port map 
		(
		  clk => f50Hz,
		  ce  => '1',
		  dir => '1',
		  rst => rst,
		  q   => f5Hz
		);
-- 5 Hz => 1Hz		
process (f5Hz, rst) 
	variable tmp: std_logic_vector(2 downto 0);
	begin
		if (f5Hz'event and f5Hz='1') then
          if (rst='0') then
				tmp := "000";
			 else
				if tmp < "011" then
					f1Hz <= '0';
				else 
					f1Hz <= '1';
				end if;
			 end if;
		end if;
	end process;
	
	 	 	 
	 
end Behavioral;